package Maze::Map;
use strict;
use Curses;
use Data::Dumper;

# Maze::Map - read in a server connection, return an AoA.
# You can see what this is doing with: 
#    [acme@localhost maze]$ perl -MData::Dumper -MMaze::Map -wle '@array = \
#    Maze::Map->new(21,20,".....................\n"x20); print Dumper(\@array)'

sub new {
    my ($class, $width, $height, $maze) = @_;

    chomp $maze;
    my @input = split "\n", $maze, $height;
    push @input, ("#" x $width);
    unshift @input, ("#" x $width);
    foreach (@input) {
      $_ = "#$_#";
    }

    my @maze = grep { @$_ }
	map {
	    [split '', substr($_,0,$width+2)]
	    } reverse @input;

    return \@maze;
}

sub print_maze {
  my $maze = shift;
  my $y = 0;
  foreach my $ys (reverse @$maze) {
    move($y++, 0);
    foreach my $xs (@$ys) {
      addstr $xs;
    }
#    addstr join(",",@$ys);
  }
  refresh;
}

1;
